using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.IO;
using DXF;
using Meta;
#if protect
using ProtectionModule;
#endif 

namespace MetafileApp
{
	public class DemoForm : System.Windows.Forms.Form
	{
		public MetaForm mf1 = null;
		private System.Windows.Forms.Button btnFormToEmf;
		private System.Windows.Forms.Button btnDemoEmf;
		private System.Windows.Forms.Button btnEmfToDXF;
		private System.Windows.Forms.Button btnFormToDXF;
		private System.Windows.Forms.SaveFileDialog dlgSave;
		private System.Windows.Forms.Button btnDemoDXF;
		private System.Windows.Forms.SaveFileDialog dlgSaveDXF;

		private Point[] arrBezier = new Point[13]{
			new Point(200, 230), new Point(190, 310), new Point(280, 330), 
			new Point(310, 310), new Point(340, 290), new Point(390, 270), 
			new Point(355, 225), new Point(330, 240), new Point(305, 255), 
			new Point(415, 255), new Point(440, 240), new Point(480, 220), 
			new Point(430, 200)};
		private System.Windows.Forms.CheckBox cbAutoCADVer;
		private System.Windows.Forms.MainMenu mMenu;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.OpenFileDialog dlgOpenEmf;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		internal System.Windows.Forms.Button button4;

		private System.ComponentModel.Container components = null;

		public DemoForm()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnDemoEmf = new System.Windows.Forms.Button();
			this.btnFormToEmf = new System.Windows.Forms.Button();
			this.btnEmfToDXF = new System.Windows.Forms.Button();
			this.btnFormToDXF = new System.Windows.Forms.Button();
			this.dlgSave = new System.Windows.Forms.SaveFileDialog();
			this.btnDemoDXF = new System.Windows.Forms.Button();
			this.dlgSaveDXF = new System.Windows.Forms.SaveFileDialog();
			this.cbAutoCADVer = new System.Windows.Forms.CheckBox();
			this.mMenu = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.dlgOpenEmf = new System.Windows.Forms.OpenFileDialog();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnDemoEmf
			// 
			this.btnDemoEmf.Location = new System.Drawing.Point(8, 144);
			this.btnDemoEmf.Name = "btnDemoEmf";
			this.btnDemoEmf.Size = new System.Drawing.Size(184, 24);
			this.btnDemoEmf.TabIndex = 0;
			this.btnDemoEmf.Text = "Create demo EMF";
			this.btnDemoEmf.Click += new System.EventHandler(this.btnDemoEmf_Click);
			// 
			// btnFormToEmf
			// 
			this.btnFormToEmf.Location = new System.Drawing.Point(8, 16);
			this.btnFormToEmf.Name = "btnFormToEmf";
			this.btnFormToEmf.Size = new System.Drawing.Size(184, 24);
			this.btnFormToEmf.TabIndex = 3;
			this.btnFormToEmf.Text = "Form To Emf ...";
			this.btnFormToEmf.Click += new System.EventHandler(this.btnFormToEmf_Click);
			// 
			// btnEmfToDXF
			// 
			this.btnEmfToDXF.Location = new System.Drawing.Point(8, 80);
			this.btnEmfToDXF.Name = "btnEmfToDXF";
			this.btnEmfToDXF.Size = new System.Drawing.Size(184, 23);
			this.btnEmfToDXF.TabIndex = 4;
			this.btnEmfToDXF.Text = "EMF convert To DXF(from Hdd)...";
			this.btnEmfToDXF.Click += new System.EventHandler(this.btnEmfToDXF_Click);
			// 
			// btnFormToDXF
			// 
			this.btnFormToDXF.Location = new System.Drawing.Point(8, 48);
			this.btnFormToDXF.Name = "btnFormToDXF";
			this.btnFormToDXF.Size = new System.Drawing.Size(184, 24);
			this.btnFormToDXF.TabIndex = 5;
			this.btnFormToDXF.Text = "Form To DXF...";
			this.btnFormToDXF.Click += new System.EventHandler(this.btnFormToDXF_Click);
			// 
			// dlgSave
			// 
			this.dlgSave.Filter = "*.emf|*.emf|*.wmf|*.wmf";
			// 
			// btnDemoDXF
			// 
			this.btnDemoDXF.Location = new System.Drawing.Point(8, 112);
			this.btnDemoDXF.Name = "btnDemoDXF";
			this.btnDemoDXF.Size = new System.Drawing.Size(184, 24);
			this.btnDemoDXF.TabIndex = 6;
			this.btnDemoDXF.Text = "Make DXF directly...";
			this.btnDemoDXF.Click += new System.EventHandler(this.btnDemoDXF_Click);
			// 
			// dlgSaveDXF
			// 
			this.dlgSaveDXF.DefaultExt = "*.dxf";
			this.dlgSaveDXF.Filter = "DXF Files(*.dxf)|*.dxf";
			// 
			// cbAutoCADVer
			// 
			this.cbAutoCADVer.Location = new System.Drawing.Point(8, 176);
			this.cbAutoCADVer.Name = "cbAutoCADVer";
			this.cbAutoCADVer.Size = new System.Drawing.Size(168, 24);
			this.cbAutoCADVer.TabIndex = 7;
			this.cbAutoCADVer.Text = "AutoCAD DXF Version R14";
			this.cbAutoCADVer.CheckedChanged += new System.EventHandler(this.cbAutoCADVer_CheckedChanged);
			// 
			// mMenu
			// 
			this.mMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				  this.menuItem1,
																				  this.menuItem2});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem4,
																					  this.menuItem5,
																					  this.menuItem6,
																					  this.menuItem7,
																					  this.menuItem10,
																					  this.menuItem8,
																					  this.menuItem9});
			this.menuItem1.Text = "&File";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.Text = "&Form paitto Emf...";
			this.menuItem4.Click += new System.EventHandler(this.btnFormToEmf_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.Text = "&Form paintto DXF...";
			this.menuItem5.Click += new System.EventHandler(this.btnFormToDXF_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 2;
			this.menuItem6.Text = "&Emf convert to DXF...";
			this.menuItem6.Click += new System.EventHandler(this.btnEmfToDXF_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 3;
			this.menuItem7.Text = "&Make DXF dirctly...";
			this.menuItem7.Click += new System.EventHandler(this.btnDemoDXF_Click);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 4;
			this.menuItem10.Text = "&Create demo Emf...";
			this.menuItem10.Click += new System.EventHandler(this.btnDemoEmf_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 5;
			this.menuItem8.Text = "-";
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 6;
			this.menuItem9.Text = "&Exit";
			this.menuItem9.Click += new System.EventHandler(this.menuItem9_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem3});
			this.menuItem2.Text = "&About";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 0;
			this.menuItem3.Text = "&About DXF Exporter...";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// dlgOpenEmf
			// 
			this.dlgOpenEmf.DefaultExt = "*.emf";
			this.dlgOpenEmf.Filter = "File Emf|*.emf";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 208);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(184, 23);
			this.button1.TabIndex = 8;
			this.button1.Text = "Create demo1 EMF(GraphicsPath)";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(8, 240);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(184, 23);
			this.button2.TabIndex = 9;
			this.button2.Text = "Create demo2 EMF(GraphicsPath)";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(8, 312);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(184, 23);
			this.button3.TabIndex = 10;
			this.button3.Text = "Create dimension demo ";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(8, 272);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(184, 23);
			this.button4.TabIndex = 17;
			this.button4.Text = "Create 3D demo";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// DemoForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.ClientSize = new System.Drawing.Size(520, 350);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.cbAutoCADVer);
			this.Controls.Add(this.btnDemoDXF);
			this.Controls.Add(this.btnFormToDXF);
			this.Controls.Add(this.btnEmfToDXF);
			this.Controls.Add(this.btnFormToEmf);
			this.Controls.Add(this.btnDemoEmf);
			this.Menu = this.mMenu;
			this.Name = "DemoForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "DXF Export C# Demo";
			this.Load += new System.EventHandler(this.DemoForm_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			this.ResumeLayout(false);

		}
		#endregion

	
		[STAThread]
		static void Main() 
		{
			Application.Run(new DemoForm());
		}

		private void btnDemoEmf_Click(object sender, System.EventArgs e)
		{	
			if(dlgSave.ShowDialog() != DialogResult.OK) return;
			if(dlgSave.FileName == "") return;
			mf1 = new MetaForm(dlgSave.FileName, ActiveForm, 500, 500, EmfType.EmfPlusDual, false);
			Draw_Demo();
			mf1.mfGraph.Dispose();
			mf1.Free();
		}

		private void btnFormToEmf_Click(object sender, System.EventArgs e)
		{	
			if(mf1 == null) return;
			if(dlgSave.ShowDialog() != DialogResult.OK) return;
			if(dlgSave.FileName == "") return; 
			mf1.SaveFromStream(dlgSave.FileName);		
		}

		private void btnEmfToDXF_Click(object sender, System.EventArgs e)
		{
			if(dlgOpenEmf.ShowDialog() != DialogResult.OK) return;
			if(dlgOpenEmf.FileName == "") return; 
			MetaForm.Splitting(dlgOpenEmf.FileName, Handle, false);		
		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if(mf1 == null) mf1 = new MetaForm(ActiveForm, EmfType.EmfPlusDual, true);
			 else return;
			Draw_Demo();
		}

		private void btnFormToDXF_Click(object sender, System.EventArgs e)
		{
			if(mf1 == null) return;
			if(dlgSaveDXF.ShowDialog() != DialogResult.OK) return;
			if(dlgSaveDXF.FileName == "") return; 
			mf1.Splitting(Handle, dlgSaveDXF.FileName, this.ClientRectangle);
		}

		private void Draw_Demo()
		{
			mf1.mfGraph.SmoothingMode = SmoothingMode.HighQuality;
			mf1.mfGraph.DrawString("DXFExport C# Demo", new Font("Times new Roman", 25, FontStyle.Underline), Brushes.Green, 200, 30);
			mf1.mfGraph.DrawString("This is ASCII string", new Font("Times new Roman", 15), Brushes.Red, 210, 10);
			mf1.mfGraph.DrawRectangle(new Pen(Color.Red, 1), 200, 70, 50, 50);
			mf1.mfGraph.FillRectangle(Brushes.Yellow, 220, 75, 25, 25);
			mf1.mfGraph.DrawLine(new Pen(Color.Blue, 1), 180, 90, 260, 90);
			Brush br1 = new HatchBrush(System.Drawing.Drawing2D.HatchStyle.ForwardDiagonal, Color.Green, ActiveForm.BackColor);
			mf1.mfGraph.FillRectangle(br1, 270, 70, 60, 60);
			br1 = new HatchBrush(System.Drawing.Drawing2D.HatchStyle.ForwardDiagonal, Color.Green, ActiveForm.BackColor);
			mf1.mfGraph.FillEllipse(br1, 350, 75, 40, 25);
			mf1.mfGraph.DrawEllipse(Pens.Black, 350, 75, 40, 25);
			mf1.mfGraph.DrawEllipse(Pens.Black, 350, 75, 40, 25);
			mf1.mfGraph.FillEllipse(Brushes.White, 400, 75, 25, 40);
			mf1.mfGraph.DrawEllipse(Pens.Black, 400, 75, 25, 40);
			Pen tmpP = new Pen(Brushes.Blue, 1);
			tmpP.DashStyle = DashStyle.DashDot;
			mf1.mfGraph.DrawEllipse(tmpP, 435, 75, 25, 50);
			br1 = new HatchBrush(System.Drawing.Drawing2D.HatchStyle.DiagonalCross, Color.Red, ActiveForm.BackColor);
			mf1.mfGraph.FillRectangle(br1, 200, 150, 50, 25);
			tmpP.DashStyle = DashStyle.Dash;
			mf1.mfGraph.DrawRectangle(tmpP, 200, 150, 50, 25);
			mf1.mfGraph.FillEllipse(Brushes.Yellow, 260, 150, 30, 30);
			mf1.mfGraph.DrawEllipse(new Pen(Color.Red, 1), 260, 150, 30, 30);
			mf1.mfGraph.DrawArc(new Pen(Color.Blue, 1), 300, 120, 60, 60, 30, 120);
			mf1.mfGraph.DrawArc(new Pen(Color.Blue, 1), 370, 120, 30, 60, 30, 120);
			mf1.mfGraph.DrawString("PolyLine", new Font("Times new Roman", 8), Brushes.Red, 210, 225);
			PointF point1 = new PointF(200.0F,  250.0F);
			PointF point2 = new PointF(210.0F,  270.0F);
			PointF point3 = new PointF(220.0F,  250.0F);
			PointF point4 = new PointF(230.0F,  270.0F);
			PointF point5 = new PointF(240.0F, 250.0F);
			PointF point6 = new PointF(250.0F, 270.0F);
			PointF point7 = new PointF(260.0F, 250.0F);
			PointF[] curvePoints = {point1, point2, point3, point4, point5, point6, point7 };
			mf1.mfGraph.DrawLines(Pens.Red, curvePoints);
			br1 = new HatchBrush(System.Drawing.Drawing2D.HatchStyle.DiagonalCross, Color.Maroon, ActiveForm.BackColor);
			mf1.mfGraph.DrawString("PolyLine Hatch", new Font("Times new Roman", 8), Brushes.Red, 275, 215);
			mf1.mfGraph.FillPolygon(br1,new PointF[]{new Point(280, 270), new Point(300, 230), new Point(340, 270)});
			Point[] arrBezier = new Point[13]{
												 new Point(400, 230), new Point(420, 250), new Point(440, 270), 
												 new Point(400, 300), new Point(360, 290), new Point(410, 270), 
												 new Point(375, 225), new Point(350, 240), new Point(325, 255), 
												 new Point(435, 255), new Point(460, 240), new Point(500, 280), 
												 new Point(450, 250)};
			mf1.mfGraph.DrawString("PolyBezier", new Font("Times new Roman", 8), Brushes.Red, 380, 215);
			mf1.mfGraph.DrawBeziers(Pens.Blue, arrBezier);
			mf1.mfGraph.Dispose();
		}

		private void btnDemoDXF_Click(object sender, System.EventArgs e)
		{
			if(dlgSaveDXF.ShowDialog() != DialogResult.OK) return;
			if(dlgSaveDXF.FileName != "") 
			{
				DXFExport vDXF = new DXFExport();
				DXFData Data = new DXFData();
				DXFLayer vLayer;
				DXFPoint Pt = new DXFPoint();
				//line types
				vDXF.AddLType("_SOLID",new float[]{5, 0});
				vDXF.AddLType("_DASH",new float[]{5,-2});
				vDXF.AddLType("_DOT", new float[]{2,-2});
				vDXF.AddLType("_DASHDOT", new float[]{5,-2,2,-2});
				vDXF.AddLType("_DASHDOTDOT", new float[]{5,-2,2,-2,2,-2});
				// {blocks}
				vDXF.BeginBlock("1");
				Data.point.X = 0;
				Data.point.Y = -3;
				Data.point1.X = 10;
				Data.point1.Y = 0;
				vDXF.AddRectangle(Data);
				Data.Clear();
				Data.height = 1;
				Data.text = "Block";
				Data.point.X = 1;
				Data.point.Y = -2;
				vDXF.AddText(Data);
				vDXF.EndBlock();
				vDXF.BeginBlock("2");
				Data.Clear();
				Data.color = ((int)DXFIntConst.DXF_OLIVE);
				Data.point.X = 0;
				Data.point.Y = 0;
				Data.radius = 40;
				vDXF.AddCircle(Data);
				vDXF.EndBlock();
				vDXF.BeginBlock("3");
				Data.Clear();
				Data.color = DXFExport.ColorToDXF(Color.Red);
				Data.count = 1;
				Data.points = new ArrayList();
				Data.points.Add(new ArrayList()); // hatch can consist of more that one bound
				Pt = new DXFPoint();
				Pt.X = 300;
				Pt.Y = -100;
				Pt.Z = 0.0f;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = -100;
				Pt.Z = 0.0f;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 100;
				Pt.Y = 0;
				Pt.Z = 0.0f;
				((ArrayList)Data.points[0]).Add(Pt);
				Data.style = ((byte)DXF.HatchStyle.hsFDiagonal);
				vDXF.fOffset = 50;
				vDXF.AddHatch(Data);
				vDXF.EndBlock();
				vDXF.BeginBlock("4"); // Bezier
				Data.Clear();
				Data.color = ((int)DXFIntConst.DXF_PURPLE);
				Data.count = arrBezier.Length;
				Data.points = new ArrayList();
				Data.points.Add(new ArrayList());
				int I;
				for(I = 0; I < Data.count; I++) 
				{
					Pt = new DXFPoint();
					Pt.X = arrBezier[I].X;
					Pt.Y = -arrBezier[I].Y;
					Pt.Z = 0;
					((ArrayList)Data.points[0]).Add(Pt);
				}
				vDXF.AddPolyBezier(Data, 0);
				vDXF.EndBlock();
				vDXF.SetLayerByString("0");
				// {entities}
				Data.Clear();
				Data.color = ((int)DXFIntConst.DXF_TEAL);
				Data.thickness = 10;
				Data.point.X = 10;
				Data.point.Y = 10;
				Data.point1.X = 20;
				Data.point1.Y = 20;
				vDXF.AddLine(Data);
				//Poly
				Data.points.Add(new ArrayList());
				Data.count = 7;
				((ArrayList)Data.points[0]).Add(new DXFPoint(200, 149, 0));
				((ArrayList)Data.points[0]).Add(new DXFPoint(210, 129, 0));
				((ArrayList)Data.points[0]).Add(new DXFPoint(220, 149, 0));
				((ArrayList)Data.points[0]).Add(new DXFPoint(230, 129, 0));
				((ArrayList)Data.points[0]).Add(new DXFPoint(240, 149, 0));
				((ArrayList)Data.points[0]).Add(new DXFPoint(250, 129, 0));
				((ArrayList)Data.points[0]).Add(new DXFPoint(260, 149, 0));
				vDXF.AddPolyLine(Data, 0);
				//
				Data.Clear();
				Data.color = ((int)DXFIntConst.DXF_OLIVE);
				Data.text = "_DASHDOT";
				Data.thickness = 1;
				Data.point.X = 12;
				Data.point.Y = 12;
				Data.radius = 45;
				vDXF.AddCircle(Data);
				Data.Clear();
				Data.height = 50;
				Data.rotation = 0;
				Data.text = "DXF Exporter";
				Data.point.X = 57;
				Data.point.Y = 76;
				vDXF.AddText(Data);
				Data.Clear();
				Data.color = DXFExport.ColorToDXF(Color.Yellow);
				Data.point.X = 80;
				Data.point.Y = 10;
				Data.point1.X = 120;
				Data.point1.Y = 30;
				vDXF.AddRectangle(Data);
				Data.Clear();
				Data.color = DXFExport.ColorToDXF(Color.Green);
				Data.text = "_DASH";
				Data.thickness = 3;
				Data.point.X = 100;
				Data.point.Y = 20;
				Data.radius = 30;
				Data.startAngle = -90;
				Data.endAngle = 90;
				vDXF.AddArc(Data);
				Data.Clear();
				vLayer = new DXFLayer("Blocks");
				vDXF.CurrentLayer = vLayer;
				Data.thickness = 0;
				Data.text = "1";
				Data.point.X = 70;
				Data.point.Y = -30;
				Data.scale.X = 3;
				Data.scale.Y = 3;
				vDXF.Insert(Data);
				Data.text = "1";
				Data.point.Y = -40;
				Data.scale.X = 5;
				Data.scale.Y = 5;
				vDXF.Insert(Data);
				Data.point.Y = -60;
				Data.scale.X = 10;
				Data.scale.Y = 10;
				vDXF.Insert(Data);
				Data.Clear();
				Data.text = "2";
				Data.point.X = 12;
				Data.point.Y = 80;
				Data.scale.X = 1;
				Data.scale.Y = 1;
				vDXF.Insert(Data);
				Data.Clear();
				vLayer = new DXFLayer("Hatch");
				vDXF.CurrentLayer = vLayer;
				Data.text = "3";
				Data.point.X = 120;
				Data.point.Y = 80;
				Data.scale.X = 1;
				Data.scale.Y = 1;
				vDXF.Insert(Data);
				Data.Clear();
				vLayer = new DXFLayer("Bezier");
				vDXF.CurrentLayer = vLayer;
				Data.text = "4";
				Data.point.X = 0;
				Data.point.Y = 200;
				Data.scale.X = 1;
				Data.scale.Y = 1;
				vDXF.Insert(Data);	
				//******************** */
				vDXF.SaveToFile(dlgSaveDXF.FileName);	
			}
		}

		private void cbAutoCADVer_CheckedChanged(object sender, System.EventArgs e)
		{
			if((sender as CheckBox).Checked) {
				DXFExport.autoCADVer = AutoCADVersion.R14;
			} else {
				DXFExport.autoCADVer = AutoCADVersion.R2000;
			}
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("DXF Export .NET " + (char)13 +
				"www.cadsofttools.com");
		}

		private void menuItem9_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			if(dlgSave.ShowDialog() != DialogResult.OK) return;
			if(dlgSave.FileName == "") return;
			MetaForm mf = new MetaForm(ActiveForm, EmfType.EmfPlusDual, false);
			GraphicsPath path = new GraphicsPath();
			path.AddLine(10, 20, 40, 20);
			mf.mfGraph.DrawPath(new Pen(Color.Blue, 1), path);
			path = new GraphicsPath();
			path.AddRectangle(new Rectangle(50, 20, 20, 20));
			mf.mfGraph.DrawPath(new Pen(Color.Red, 1), path);
			path = new GraphicsPath();
			path.AddArc(95, 20, 20, 20, 0, 90);
			mf.mfGraph.DrawPath(new Pen(Color.Green, 1), path);
			path = new GraphicsPath();
			path.AddEllipse(135, 20, 20, 30);
			mf.mfGraph.DrawPath(new Pen(Color.Maroon, 1), path);
			path = new GraphicsPath();
			PointF point1 = new PointF(200.0F,  30.0F);
			PointF point2 = new PointF(210.0F,  50.0F);
			PointF point3 = new PointF(220.0F,  30.0F);
			PointF point4 = new PointF(230.0F,  50.0F);
			PointF point5 = new PointF(240.0F, 30.0F);
			PointF point6 = new PointF(250.0F, 50.0F);
			PointF point7 = new PointF(260.0F, 30.0F);
			PointF[] points1 = {point1, point2, point3, point4, point5, point6, point7 };
			path.AddLines(points1);
			mf.mfGraph.DrawPath(new Pen(Color.Magenta, 1), path);
			path = new GraphicsPath();
			path.AddBezier(10, 90, 15, 90, 10, 110, 30, 90);
			mf.mfGraph.DrawPath(new Pen(Color.Blue, 1), path);
			path = new GraphicsPath();
			Point[] arrBezier = new Point[13]{
												 new Point(60, 90), new Point(65, 110), new Point(75, 120), 
												 new Point(60, 140), new Point(50, 130), new Point(68, 120), 
												 new Point(70, 95), new Point(80, 115), new Point(75, 125), 
												 new Point(80, 120), new Point(85, 110), new Point(90, 140), 
												 new Point(75, 95)};
			path.AddBeziers(arrBezier);
			mf.mfGraph.DrawPath(new Pen(Color.Red, 1), path);
			path = new GraphicsPath();
			PointF[] points2 = new PointF[4];
			points2[0] = new Point(95, 90);
			points2[1] = new Point(110, 100);
			points2[2] = new Point(98, 110);
			points2[3] = new Point(130, 130);
			path.AddCurve(points2);
			mf.mfGraph.DrawPath(new Pen(Color.Green, 1), path);
			path = new GraphicsPath();
			points2[0] = new Point(145, 90);
			points2[1] = new Point(160, 100);
			points2[2] = new Point(148, 110);
			points2[3] = new Point(180, 130);
			path.AddClosedCurve(points2);
			mf.mfGraph.DrawPath(new Pen(Color.Maroon, 1), path);
			path = new GraphicsPath();
			path.AddPie(220, 90, 20, 30, 40, 240);
			mf.mfGraph.DrawPath(new Pen(Color.Magenta, 1), path);
			path = new GraphicsPath();
			path.AddEllipse(10, 180, 30, 20);
			mf.mfGraph.DrawPath(new Pen(Color.Blue, 1), path);
			// Move the ellipse 100 points to the right.
			Matrix translateMatrix = new Matrix();
			translateMatrix.Translate(50, 0);
			path.Transform(translateMatrix);
			// Draw the transformed ellipse to the screen.
			mf.mfGraph.DrawPath(new Pen(Color.Red, 2), path);
			mf.mfGraph.Dispose();
			mf.SaveFromStream(dlgSave.FileName);
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			if(dlgSave.ShowDialog() != DialogResult.OK) return;
			if(dlgSave.FileName == "") return;
			MetaForm mf = new MetaForm(ActiveForm, EmfType.EmfPlusDual, false);
			GraphicsPath path = new GraphicsPath();
			path.AddRectangle(new Rectangle(200, 70, 50, 50));
			mf.mfGraph.DrawPath(new Pen(Color.Green, 1), path);
			path = new GraphicsPath();
			path.AddRectangle(new Rectangle(220, 75, 25, 25));
			path.AddLine(180, 90, 260, 90);
			path.AddLine(180, 90, 260, 90);
			mf.mfGraph.DrawPath(new Pen(Color.Yellow, 1), path);
			path = new GraphicsPath();
			path.AddRectangle(new Rectangle(270, 70, 60, 60));
			path.AddEllipse(350, 75, 40, 25);
			path.AddEllipse(400, 75, 25, 40);
			path.AddEllipse(435, 75, 25, 50);
			path.StartFigure();
			path.AddArc(300, 120, 60, 60, 30, 120);
			path.CloseFigure();
			path.AddArc(370, 120, 30, 60, 30, 120);	
			path.StartFigure();
			PointF point1 = new PointF(200.0F,  250.0F);
			PointF point2 = new PointF(210.0F,  270.0F);
			PointF point3 = new PointF(220.0F,  250.0F);
			PointF point4 = new PointF(230.0F,  270.0F);
			PointF point5 = new PointF(240.0F, 250.0F);
			PointF point6 = new PointF(250.0F, 270.0F);
			PointF point7 = new PointF(260.0F, 250.0F);
			PointF[] curvePoints = {point1, point2, point3, point4, point5, point6, point7 };
			path.AddLines(curvePoints);
			path.CloseFigure();
			Point[] arrBezier = new Point[13]{
												 new Point(400, 230), new Point(420, 250), new Point(440, 270), 
												 new Point(400, 300), new Point(360, 290), new Point(410, 270), 
												 new Point(375, 225), new Point(350, 240), new Point(325, 255), 
												 new Point(435, 255), new Point(460, 240), new Point(500, 280), 
												 new Point(450, 250)};
			path.AddBeziers(arrBezier);
			mf.mfGraph.DrawPath(new Pen(Color.Red, 2), path);
			mf.mfGraph.Dispose();
			mf.SaveFromStream(dlgSave.FileName);
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			if(dlgSaveDXF.ShowDialog() != DialogResult.OK) return;
			if(dlgSaveDXF.FileName != "") 
			{
				DimensionStyle vDimStyle = new DimensionStyle();
				DXFExport vDXF = new DXFExport();
				DXFData Data = new DXFData();

				DXFLayer vLayer = new DXFLayer("Dimensions");
				vDXF.CurrentLayer = vLayer;
				Data.color = (int)DXFIntConst.DXF_WHITE;
				Data.point = new DXFPoint(400, 10, 0);
				Data.point1 = new DXFPoint(430, 30, 0);
				vDXF.AddRectangle(Data);
				Data.Clear();
				vDimStyle.arrow1 = DimensionArrowType.Open;
				vDimStyle.arrow2 = DimensionArrowType.None;
				vDimStyle.arrowSize = 3.0f;
				vDimStyle.extLineExt = 0.5f;
				vDimStyle.extLineOffset = 0.1f;
				vDimStyle.textOffset = 0.1f;
				vDimStyle.textHeight = 1;
				Data.styleObject = vDimStyle;
				Data.color = (int)DXFIntConst.DXF_GREEN;
				Data.text = "Text override";
				Data.point = new DXFPoint(440, 20.0f, 0.0f);
				Data.point1 = new DXFPoint(430, 10.0f, 0.0f);
				Data.point2 = new DXFPoint(430, 30.0f, 0.0f);
				vDXF.AddDimension(Data);
				Data.Clear();
				vDimStyle.arrow1 = DimensionArrowType.Closed;
				vDimStyle.arrow2 = DimensionArrowType.ClosedFilled;
				vDimStyle.arrowSize = 1.0f;
				vDimStyle.extLineExt = 0.1f;
				vDimStyle.extLineOffset = 0.1f;
				vDimStyle.textOffset = 0.1f;
				vDimStyle.textHeight = 0.5f;
				Data.styleObject = vDimStyle;
				Data.color = (int)DXFIntConst.DXF_GREEN;
				Data.point = new DXFPoint(410, 35.0f, 0.0f);
				Data.point1 = new DXFPoint(400, 30.0f, 0.0f);
				Data.point2 = new DXFPoint(430, 30.0f, 0.0f);
				vDXF.AddDimension(Data);
				Data.Clear();
				vDimStyle.arrow1 = DimensionArrowType.ClosedFilled;
				vDimStyle.arrow2 = DimensionArrowType.ClosedBlank;
				vDimStyle.arrowSize = 5.0f;
				vDimStyle.extLineExt = 0.5f;
				vDimStyle.extLineOffset = 0.4f;
				vDimStyle.textOffset = 0.4f;
				vDimStyle.textHeight = 2;
				Data.styleObject = vDimStyle;
				Data.color = (int)DXFIntConst.DXF_TEAL;
				Data.point = new DXFPoint(390, 20.0f, 0.0f);
				Data.point1 = new DXFPoint(400, 10.0f, 0.0f);
				Data.point2 = new DXFPoint(400, 30.0f, 0.0f);
				vDXF.AddDimension(Data);
				Data.Clear();
				vDimStyle.arrow1 = DimensionArrowType.Origin;
				vDimStyle.arrow2 = DimensionArrowType.Origin2;
				vDimStyle.arrowSize = 2.0f;
				vDimStyle.extLineExt = 0.18f;
				vDimStyle.extLineOffset = 0.2f;
				vDimStyle.textOffset = 0.2f;
				vDimStyle.textHeight = 1.5f;
				Data.styleObject = vDimStyle;
				Data.color = (int)DXFIntConst.DXF_TEAL;
				Data.point = new DXFPoint(410, 5.0f, 0.0f);
				Data.point1 = new DXFPoint(400, 10.0f, 0.0f);
				Data.point2 = new DXFPoint(430, 10.0f, 0.0f);
				vDXF.AddDimension(Data);
				//=====================end of Dimensions ====================*/
				vDXF.SaveToFile(dlgSaveDXF.FileName);
			}
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			if(dlgSaveDXF.ShowDialog() != DialogResult.OK) 
				return;
			if(dlgSaveDXF.FileName != "") 
			{
				DXFExport vDXF = new DXFExport();
				DXFData Data = new DXFData();
				DXFPoint Pt;
				Data.Clear();
				Data.color = (int)DXFIntConst.DXF_RED;
				Data.thickness = 1;
				Data.point.X = 0;
				Data.point.Y = 0;
				Data.point.Z = 0;
				Data.point1.X = 100;
				Data.point1.Y = 0;
				Data.point1.Z = 0;
				vDXF.AddLine(Data);
				Data.Clear();
				Data.color = (int)DXFIntConst.DXF_LIME;
				Data.thickness = 1;
				Data.point.X = 0;
				Data.point.Y = 0;
				Data.point.Z = 0;
				Data.point1.X = 0;
				Data.point1.Y = 100;
				Data.point1.Z = 0;
				vDXF.AddLine(Data);
				Data.Clear();
				Data.color = (int)DXFIntConst.DXF_BLUE;
				Data.thickness = 1;
				Data.point.X = 0;
				Data.point.Y = 0;
				Data.point.Z = 0;
				Data.point1.X = 0;
				Data.point1.Y = 0;
				Data.point1.Z = 100;
				vDXF.AddLine(Data);

				Data.Clear();
				Data.count = 1;
				Data.color = (int)DXFIntConst.DXF_BLUE;
				Data.points = new ArrayList();
				Data.points.Add(new ArrayList());   // hatch can consist of more that one bound
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 100;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 100;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Data.style = (byte)DXF.HatchStyle.hsFDiagonal;
				vDXF.fOffset = 10;
				vDXF.AddHatch(Data);

				Data.Clear();
				Data.count = 1;
				Data.color = (int)DXFIntConst.DXF_RED;
				Data.points = new ArrayList();
				Data.points.Add(new ArrayList());  // hatch can consist of more that one bound
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 100;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 100;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Data.style = (byte)DXF.HatchStyle.hsFDiagonal;
				Pt = new DXFPoint();
				Pt.X = 1;
				Pt.Y = 0;
				Pt.Z = 0;
				Data.point3 = Pt;
				vDXF.fOffset = 10;
				vDXF.AddHatch(Data);

				Data.Clear();
				Data.count = 1;
				Data.color = (int)DXFIntConst.DXF_GREEN;
				Data.points = new ArrayList();
				Data.points.Add(new ArrayList());   // hatch can consist of more that one bound
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 100;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 100;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Data.style = (byte)DXF.HatchStyle.hsHorizontal;
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 0;
				Pt.Z = 100;
				Data.point2 = Pt;
				vDXF.fOffset = 20;
				vDXF.AddHatch(Data);
				Data.Clear();

				Data.count = 1;
				Data.color = (int)DXFIntConst.DXF_YELLOW;
				Data.points = new ArrayList();
				Data.points.Add(new ArrayList()); //hatch can consist of more that one bound
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 100;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 100;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Data.style = (byte)DXF.HatchStyle.hsDiagCross;
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 0;
				Pt.Z = 100;
				Data.point2 = Pt;
				Pt = new DXFPoint();
				Pt.X = 1;
				Pt.Y = 0;
				Pt.Z = 0;
				Data.point3 = Pt;
				vDXF.fOffset = 30;
				vDXF.AddHatch(Data);
				Data.Clear();

				Data.count = 1;
				Data.color = (int)DXFIntConst.DXF_FUCHSIA;
				Data.points = new ArrayList();
				Data.points.Add(new ArrayList());   // hatch can consist of more that one bound
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 100;
				Pt.Y = 0;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 100;
				Pt.Z = 0;
				((ArrayList)Data.points[0]).Add(Pt);
				Data.style = (byte)DXF.HatchStyle.hsCross;
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 0;
				Pt.Z = 100;
				Data.point2 = Pt;
				Pt = new DXFPoint();
				Pt.X = 0;
				Pt.Y = 1;
				Pt.Z = 0;
				Data.point3 = Pt;
				vDXF.fOffset = 40;
				vDXF.AddHatch(Data);
				vDXF.SaveToFile(dlgSaveDXF.FileName);
			}
		}

		private void DemoForm_Load(object sender, System.EventArgs e)
		{
			#if protect
				Protection.Register();
			#endif
		}
	}
}
